//! This module helps us deal with controls and events.

use std::cell::RefCell;
use std::collections::{HashMap, VecDeque};
use std::rc::Rc;

use wasm_bindgen::prelude::*;
use wasm_bindgen::JsCast;

use crate::Result;

/// The different actions that a user can do.
#[derive(Copy, Clone)]
pub enum Action {
    /// The user asks to go to the left.
    GoLeft,

    /// The user asks to go to the right.
    GoRight,

    /// The user asks to go up.
    GoUp,

    /// The user asks to go down.
    GoDown,

    /// The user asks to do the main action or validate.
    Button1,

    /// The user asks to do the secondary action.
    Button2,

    /// The user asks to do the tertiary action.
    Button3,

    /// The user asks to do the 4th action or cancel.
    Button4,
}
